<template>
	<v-divider
		class="border-opacity-100"
		color="#E4E4E4"
		:thickness="2"
	></v-divider>
	<v-container class="ma-auto pt-8 pb-12">
		<v-sheet width="384">
			<form @submit.prevent="onSubmit">
				<div :class="{ error: v$.car.vin.$errors.length }">
					<label>VIN</label>
					<span> *</span>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						class="mt-2"
						rounded="lg"
						variant="outlined"
						v-model="car.vin"
						@blur="v$.car.vin.$touch"
						hide-details="auto"
					>
					</v-text-field>
					<div v-for="error of v$.car.vin.$errors" :key="error.$uid">
						<small class="error-msg text-red">{{ error.$message }}</small>
					</div>
				</div>

				<div class="mt-6 mb-3">
					<label>Make</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.make"
					>
					</v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>Model</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.model"
					></v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>Body type</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.bodyType"
					></v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>Fuel type</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.fuelType"
					></v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>Hp</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.hp"
					></v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>CMM</label>
					<v-text-field
						base-color="#293148"
						color="#E4E4E4"
						rounded="lg"
						class="mt-2"
						variant="outlined"
						hide-details
						v-model="car.cmm"
					></v-text-field>
				</div>

				<div class="mt-6 mb-3">
					<label>Description</label>
					<v-textarea
						base-color="#293148"
						color="#E4E4E4"
						auto-grow
						variant="outlined"
						rows="3"
						row-height="25"
						shaped
						hide-details
						v-model="car.description"
					></v-textarea>
				</div>

				<v-btn
					rounded="lg"
					class="mt-8"
					color="#D90E32"
					height="48"
					block
					type="submit"
				>
					add vechicle
				</v-btn>
			</form>
		</v-sheet>
	</v-container>
</template>

<script>
import { useVuelidate } from '@vuelidate/core'
import { required } from '@vuelidate/validators'
import { mapMutations } from 'vuex'

export default {
	name: 'CreateVehiclesPage',
	setup() {
		return { v$: useVuelidate() }
	},
	data() {
		return {
			car: {
				vin: '',
				make: '',
				model: '',
				bodyType: '',
				fuelType: '',
				hp: '',
				cmm: '',
				description: '',
			},
			newCar: {},
		}
	},
	validations() {
		return {
			car: {
				vin: { required },
			},
		}
	},
	methods: {
		...mapMutations(['createCar']),

		onSubmit() {
			if (this.v$.$invalid) {
				this.v$.$touch()
				return
			}

			console.log('Валидация успешно пройдена!')

			this.newCar = { id: Date.now(), ...this.car }
			this.createCar({ ...this.newCar })
			this.$router.push(`/vehicles/${this.newCar.id}`)
		},
	},
}
</script>

<style></style>
